package rrf.pingauges2;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

/**
 * Created by Robert R. Fenichel on 12/15/2015.
 */
public class PinsToHole extends AppCompatActivity
  {
    private Button   btnFindHole;
    private EditText edNomPinOD1;
    private EditText edNomPinOD2;
    private EditText edNomPinOD3;
    private TextView lbHole;

    private double GetNomPinOD(EditText edNom)
      { String S = edNom.getText().toString().trim();
        double BeforeOffset;

        BeforeOffset = Float.valueOf(S);
        if (!S.contains("."))
          { BeforeOffset = BeforeOffset / dmPinGauges.TheConfiguration.PinFormatFactor; }
        edNom.setText(dmPinGauges.FormatPin(BeforeOffset));
        return BeforeOffset;
      } // GetNomPinOD

    @Override
    protected void onCreate(Bundle SavedState)
      {
        super.onCreate(SavedState);
        setContentView(R.layout.pins_to_hole);

        edNomPinOD1 = (EditText) findViewById(R.id.edNomPinOD1);
        edNomPinOD1.addTextChangedListener(TheWatcher);

        edNomPinOD2 = (EditText) findViewById(R.id.edNomPinOD2);
        edNomPinOD2.addTextChangedListener(TheWatcher);

        edNomPinOD3 = (EditText) findViewById(R.id.edNomPinOD3);
        edNomPinOD3.addTextChangedListener(TheWatcher);

        btnFindHole = (Button)   findViewById(R.id.btnFindHole);
        btnFindHole.setOnClickListener(new View.OnClickListener()
          {
            @Override
            public void onClick(View v)
              {
                double NomOD1 = GetNomPinOD(edNomPinOD1);
                double NomOD2 = GetNomPinOD(edNomPinOD2);
                double NomOD3 = GetNomPinOD(edNomPinOD3);

                double HoleOD = Engine.CircumscribeThree(NomOD1 + dmPinGauges.TheConfiguration.PinOffset,
                                                         NomOD2 + dmPinGauges.TheConfiguration.PinOffset,
                                                         NomOD3 + dmPinGauges.TheConfiguration.PinOffset);

                String strTuple = Engine.FormatTuple(NomOD1, NomOD2, NomOD3);
                String strTupleHole = Engine.FormatTupleHole(NomOD1, NomOD2, NomOD3, HoleOD);

                switch (Engine.LastFit)
                  {
                    case Engine.fitInfinite:
                      lbHole.setText(String.format(getString(R.string.infinite), strTuple));    break;
                    case Engine.fitLoose:
                      lbHole.setText(String.format(getString(R.string.loose),   strTupleHole)); break;
                    case Engine.fitOffside:
                      lbHole.setText(String.format(getString(R.string.offside), strTupleHole)); break;
                    case Engine.fitSnug:
                      lbHole.setText(strTupleHole);                                             break;
                    case Engine.fitUndefined:
                      lbHole.setText(String.format(getString(R.string.undefined), strTuple));   break;
                  } // switch
              } // the listener
          }); // set onClickListener
        btnFindHole.setEnabled(false);

        lbHole      = (TextView) findViewById(R.id.lbHole);
        lbHole.setText(null);
      } // onCreate

    private final TextWatcher TheWatcher = new TextWatcher()
      {
        @Override
        public void beforeTextChanged(CharSequence s, int start, int count, int after)
          { } // before text changed; intentionally null

        @Override
        public void onTextChanged(CharSequence s, int start, int before, int count)
          { String S1 = edNomPinOD1.getText().toString().trim();
            String S2 = edNomPinOD2.getText().toString().trim();
            String S3 = edNomPinOD3.getText().toString().trim();

            btnFindHole.setEnabled(false);
            boolean TentativelyOK = (S1.length() > 0) && (S2.length() > 0) && (S3.length() > 0);
            if (TentativelyOK)
              {
                if (!S1.equals(".") && !S2.equals(".") && !S3.equals("."))
                  { btnFindHole.setEnabled((Float.valueOf(S1) > 0) &&
                                           (Float.valueOf(S2) > 0) &&
                                           (Float.valueOf(S3) > 0)
                                          );
                  } // might be enabled
              } // all nonnull
          } // onTextChanged

        @Override
        public void afterTextChanged(Editable s)
        { lbHole.setText(""); } // after text changed; intentionally null
      }; // define TextChangedListener


    //landscape layout not needed
  } // PinsToHole
